<? 
/***************************************
** Title........: HTML parse library - class where parsing settings are incapsulated
** Filename.....: settings.inc.php
** Author.......: Elena Alekseeva aka Felenka
** Version......: 1.2
** Notes........:
** Last changed.: 15 Sept 2002
** Last change..: Constructor and initialization function are optimized; comments are provided
***************************************/

require_once(INCLUDE_DIR.'const.inc.php');

class parseRules
{
    var $varname, /* contains RegEx to parse variable name */
	$filename, /* contains RegEx to parse file name, including path */
	$funcname, /* contains RegEx to parse function name */
	$tagname, /* contains RegEx to parse the tagname - LETTERS ONLY */
	$tagorigin, /* conatins the originale tagname */
    	$varnum, /* the number used in 'preg_replace' to use the variable name */
    	$varstart, /* contains RegEx to find where variable name is started */
    	$varend, /* contains RegEx to find where variable name is finished */
	$basic, /* contains the number of external standard function names */
	$stand, /* contains the number of basic standard function names */
	$taginner; /* contains RegEx to parse the inner of function tagname */
	
function parseRules( $basic = array('parseStr', 'parseFile', 'parseTag') )
{
	for ($i = 0; $i < sizeof($basic); $i++ ){
		if ( function_exists($basic[$i]) )
			$this->basic[] = $basic[$i];
	}	
	
	$this->stand = array();
	
	$this->varname = DEFAULT_VARNAME_REGEX;
	$this->countVarStartNum();
	$this->filename = DEFAULT_FILENAME_REGEX;
	$this->funcname = DEFAULT_FUNCNAME_REGEX;
	$this->taginner = DEFAULT_TAGINNER_REGEX;
	$this->varstart = preg_quote(DEFAULT_VARNAME_START, '/');
	$this->varend = preg_quote(DEFAULT_VARNAME_END, '/');
	$this->tagorigin = eregi_replace('[^a-z]', '', DEFAULT_TAGNAME);
	$this->tagname = makeStrCaseI($this->tagorigin);

	return;
}

function init($pars = array() )
{
	foreach ( get_object_vars($this) as $varname => $val ){	
		$varname = strtolower($varname);
		if ($varname == 'varnum' || $varname == 'tagname' || empty($pars[$varname]))
			continue;
		
		if ( $varname == 'tagorigin' )
			$this->makeValidTag($pars['tagorigin']);
		else if ( $varname == 'stand' || $varname == 'basic' )
			$this->makeValidFuncList($varname, $pars[$varname]);
		else if ( $varname == 'varstart' || $varname == 'varend' )
			$this->makeValidVarPart($varname, $pars[$varname]);
		else
			$this->$varname = $pars[ $varname ]; 
			
	}
	return;
}

function  countVarStartNum(){
	$this->varnum = 2 + substr_count($this->varstart,'(');
}

function makeValidTag($tag){ // $tag shouldn't be empty
	$this->tagorigin = eregi_replace('[^a-z]', '', $tag);
	$this->tagname = makeStrCaseI($this->tagorigin);
}

function makeValidFuncList($varname, &$list){
	toArray($list);
	foreach ($list as $func){
		if ( function_exists($func) )
			array_push ($this->$varname, $func);
	}
	$this->$varname = array_unique( $this->$varname );
}

function makeValidVarPart($varname, $varpart){ // $varpart shouldn't be empty
	$this->$varname = preg_quote($varpart, '/');
	if ( $varname == 'varstart' )
		$this->countVarStartNum();
}


}
?>